[leetcode] 239. Sliding Window Maximum

Description

You are given an array of integers nums, there is a sliding window of size k which is moving from the very left of the array to the very right. You can only see the k numbers in the window. Each time the sliding window moves right by one position.

Return the max sliding window.

Example 1:

Input: nums = [1,3,-1,-3,5,3,6,7], k = 3
Output: [3,3,5,5,6,7]
Explanation: 
Window position                Max
---------------               -----
[1  3  -1] -3  5  3  6  7       3
 1 [3  -1  -3] 5  3  6  7       3
 1  3 [-1  -3  5] 3  6  7       5
 1  3  -1 [-3  5  3] 6  7       5
 1  3  -1  -3 [5  3  6] 7       6
 1  3  -1  -3  5 [3  6  7]      7

Example 2:

Input: nums = [1], k = 1
Output: [1]

Example 3:

Input: nums = [1,-1], k = 1
Output: [1,-1]

Example 4:

Input: nums = [9,11], k = 2
Output: [11]

Example 5:

Input: nums = [4,-2], k = 2
Output: [4]

Constraints:

  1. 1 <= nums.length <= 105
  2. -104 <= nums[i] <= 104
  3. 1 <= k <= nums.length

分析

题目的意思是:求出滑动窗口内的最大值。这道题用队列存储遍历的索引,我只能写出简单的暴力破解版本,发现AC不了。学习一下别人的思路:

  • 如果双端队列非空,存储的值超过了windows大小,则把双端队列队头的值移除;+ 如果当前的队列非空,移除小于当前加入元素值的索引;
  • 如果当前的索引大于等于k-1,则更新最大值

代码

class Solution:
    def maxSlidingWindow(self, nums: List[int], k: int) -> List[int]:
        n=len(nums)
        q=deque()
        res=[]
        for i in range(n):
            if(q and q[0]<=i-k): # 移除队头
                q.popleft()
            while(q and nums[i]>nums[q[-1]]): # 移除小于当前要加入元素的值的索引
                q.pop()
            q.append(i)
            if(i>=k-1): # 更新最大值
                res.append(nums[q[0]])
        return res

参考文献

每日算法系列【LeetCode 239】滑动窗口最大值

上一篇:题型总结之Sliding Window


下一篇:android – 在屏幕上滑动手指激活按钮,就像按下它们一样